// ------------------------------------------------------------------------------------------ //
//                     B D F X T R E N D E R   I N D I C A T O R                              //
//                          by fosgate_r     January 2009                                    //
//                      URL : http://forexfreeea.blogspot.com/                                //
// ------------------------------------------------------------------------------------------ //


#property copyright " January 2009 fosgate_r"
#property link "http://forexfreeea.blogspot.com/"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red


// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern string TimeFrame       = "Current time frame";
extern int    LsmaPeriod      = 100;
extern int    MaPeriod        = 7;
extern int    MaMode          = MODE_EMA;
extern int    MaPrice         = PRICE_TYPICAL;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Space1[], Space2[], Space3[], Space5[], trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   IndicatorBuffers (5);
   SetIndexBuffer (2,Space1);
   SetIndexBuffer (1,Space2);
   SetIndexBuffer (0,Space3);
   SetIndexBuffer (3,Space5);
   SetIndexBuffer (4,trend);
   SetIndexStyle  (2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle  (1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle  (0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"  BDFXtrender");  
return(0);
}  


// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Space3[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {   
     for (i=limit; i>=0; i--)
     {
        Space5[i] = 3.0 * iMA(NULL,0,LsmaPeriod,0,MODE_LWMA,0,i) - 2.0 * iMA(NULL,0,LsmaPeriod,0,MODE_SMA,0,i);
        double B2 = iMA(NULL,0,MaPeriod,0,MaMode,MaPrice,i);
        trend[i]  = trend[i+1];
        Space3[i] = Space5[i];
        Space2[i] = Space5[i];
        Space1[i] = Space5[i];
      
        if (((Space5[i+1]>Space5[i]) && (Space5[i]>B2))== 1) { Space2[i] = EMPTY_VALUE; trend[i] =-1;           }
        else 
        {  
        if (((Space5[i+1]<Space5[i]) && (Space5[i]<B2))== 1) { Space1[i] = EMPTY_VALUE; trend[i] = 1;           }
        else                                                 { Space1[i] = EMPTY_VALUE; Space2[i]= EMPTY_VALUE; }
      }
      
    }
   manageAlerts();
   return(0);
   }
      
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Space1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LsmaPeriod,MaPeriod,MaMode,MaPrice,2,y);
         Space2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LsmaPeriod,MaPeriod,MaMode,MaPrice,1,y);
         Space3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LsmaPeriod,MaPeriod,MaMode,MaPrice,0,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",LsmaPeriod,MaPeriod,MaMode,MaPrice,4,y);
   }
   manageAlerts();  
return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" BDFXtrender ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  BDFXtrender "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
            
               
     
  
     
   

//
//
//
//
//


